//+------------------------------------------------------------------+
//| SolarWindClean X mtf (based on Solar wind clean (FisherTransform)|
//| revised by Mladen    Copyright  2005, MetaQuotes Software Corp. |
//| ForexTSD mladen nittany  mod fxbs  ki http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2005,  MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/ www.ForexTSD.com"

//---- indicator settings

#property  copyright ""
#property  link      ""

#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Lime
#property  indicator_color2  Red
#property  indicator_minimum 0
#property  indicator_maximum 2
#property  indicator_width1  2
#property  indicator_width2  2

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    period          = 10;
extern int    smoozing        = 2;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav"; 

//
//
//
//
//

double  ExtBuffer0[];
double  ExtBuffer1[];
double  ExtBuffer2[];
double  Value[];
double  ExtBuffer3[];
double  trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,ExtBuffer1);  SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159);
   SetIndexBuffer(1,ExtBuffer2);  SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
   SetIndexBuffer(2,ExtBuffer0);
   SetIndexBuffer(3,Value);
   SetIndexBuffer(4,ExtBuffer3);
   SetIndexBuffer(5,trend);
   
      //
      //
      // 
      //
      //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
 
   IndicatorShortName(timeFrameToString(timeFrame)+"  SOLARWIND CleanX ("+period+")("+smoozing+")");
   return(0);
}


int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ExtBuffer1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
     for(i=limit; i>=0; i--)
     {  
        double MaxH  = High[iHighest(NULL,0,MODE_HIGH,period,i)];
        double MinL  = Low [iLowest( NULL,0,MODE_LOW, period,i)];
        double price = (High[i]+Low[i])/2;
        if (MaxH!=MinL)
              Value[i] = 0.33*2*((price-MinL)/(MaxH-MinL)-0.5);
        else  Value[i] = 0.00;
              Value[i] = MathMin(MathMax(Value[i],-0.999),0.999); 
              ExtBuffer0[i]=0.5*MathLog((1+Value[i])/(1-Value[i]));

    }     

    for(i=limit; i>=0; i--)
    {
       ExtBuffer3[i]=iMAOnArray(ExtBuffer0,0,smoozing,0,MODE_EMA,i);
       ExtBuffer1[i]=EMPTY_VALUE;
       ExtBuffer2[i]=EMPTY_VALUE;
       trend[i]=trend[i+1];
       if(ExtBuffer3[i]<0) trend[i] =-1;
       if(ExtBuffer3[i]>0) trend[i] = 1;
       if (trend[i] ==-1)  ExtBuffer2[i]=1;
       if (trend[i] == 1)  ExtBuffer1[i]=1;
     
    }
    manageAlerts();
    return(0);
    }
      
    //
    //
    //
    //
    //
   
    limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    for (i=limit;i>=0; i--)
    {
        int y = iBarShift(NULL,timeFrame,Time[i]);
           ExtBuffer1[i] = EMPTY_VALUE;
           ExtBuffer2[i] = EMPTY_VALUE;
           trend[i]      = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",period,smoozing,5,y);
           if (trend[i] ==-1)  ExtBuffer2[i]=1;
           if (trend[i] == 1)  ExtBuffer1[i]=1;
    }
   manageAlerts();  
return(0);         
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (! calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" Solar Wind ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Solar Wind "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}



